﻿using System;
using System.Windows.Forms;
using C1.Win.C1Input;

namespace WindowsFormsApp1
{
    public class MyDateEdit : C1DateEdit
    {
        private Timer _timer;
        private bool _updateOnClick = false;
        private bool _entering = false;

        public MyDateEdit()
        {
            _timer = new Timer() { Interval = 10 };
            _timer.Tick += _timer_Tick;
        }

        private void _timer_Tick(object sender, EventArgs e)
        {
            _entering = false;
            _timer.Stop();
        }

        protected override void OnEnter(EventArgs e)
        {
            base.OnEnter(e);
            _entering = true;
            _timer.Start();
        }

        protected override void OnLeave(EventArgs e)
        {
            base.OnLeave(e);
            _entering = false;
            _updateOnClick = false;
        }

        protected override void OnMouseDown(MouseEventArgs e)
        {
            base.OnMouseDown(e);
            if (_entering)
                _updateOnClick = true;
        }

        protected override void OnMouseUp(MouseEventArgs e)
        {
            base.OnMouseUp(e);
            if (_updateOnClick)
            {
                UpdateSelection();
                _updateOnClick = false;
            }
        }
    }
}